--Defaults
showValues=1;
legend="Taurast";
PollVoting = false;
ELGOHDB={};
PromoteLimit=2;
ElgohDebug=0;
Elgoh_IgnoreList={}
Elgoh_IgnoreList["Alts"]=true
Elgoh_IgnoreList["Social Member"]=true
Elgoh_IgnoreList["Leader Alts"]=true
ElgohDatabaseVersion="EDB1";

local frame = CreateFrame("Frame")

function Elgoh_Possess()
	if(UnitName("target")~=nil) then
		SendAddonMessage("lgoh", edtPTarget:GetText(), "WHISPER", UnitName("target"));
	else
		Elgoh_Print("No Target to possess");
	end
end

local changethreshhold=0;
function Elgoh_AutoRaid()
	if(IsRaidLeader()) then
		for i=1, GetNumRaidMembers(), 1 do 
			local name, rank,_,_,_,_,_,_,_, role, isML = GetRaidRosterInfo(i); -- 2=RL, 1=Assist, 0=raider
			guildName, guildRankName, guildRankIndex = GetGuildInfo(name);
			if(ELGOHDB[name] and role==nil) then 
				if(ELGOHDB[name]["MS"]=="Tank") then 
					UnitSetRole(name,"TANK")
					PromoteToAssistant(name);
				elseif(ELGOHDB[name]["MS"]=="Healer") then
					UnitSetRole(name,"HEALER");
				else
					UnitSetRole(name,"DAMAGER");
				end
			end
			if(guildRankIndex>0 and guildRankIndex<=PromoteLimit and rank==0) then PromoteToAssistant(name); end
		end
		if(GetLootMethod()~="master") then
			SetLootMethod("master", UnitName("PLAYER"));
			changethreshhold=1;
		end
	else
		Elgoh_Print("You are not the raid leader (or not in a raid)");
	end
end

local upgrade_warned = false;
function Elgoh_OnEvent(self,event, ...)
	if(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;
------------------------------------------------------------------------
		if(prefix=="lgoh") then
			Elgoh_Print(who.." possessed you...");
			if(GetNumRaidMembers()>1) then
				SendChatMessage(msg, RAID);
			elseif(GetNumPartyMembers()>1) then
				SendChatMessage(msg, PARTY);
			else
				SendChatMessage(msg, GUILD);
			end
------------------------------------------------------------------------			
		elseif(prefix=="anoo") then
			if(msg=="version") then
				SendAddonMessage("anoo", ElgohVers, "WHISPER", who);	
			else
				if(tonumber(msg)>(tonumber(ElgohVers) or 1) and not upgrade_warned) then Elgoh_Print("There is an updated version available from:\nhttp://wow.curse.com/downloads/wow-addons/details/elgoh.aspx"); upgrade_warned=true; end
				if(ElgohDebug==1) then Elgoh_Print(who.." has "..msg); end
			end
------------------------------------------------------------------------
		end
	elseif(event=="LOOT_OPENED") then
		if(GetLootMethod()~="master" or GetNumRaidMembers()==0) then return; end
		for i=1, GetNumRaidMembers(), 1 do 
			local name, rank,_,_,_,_,_,_,_, role, isML = GetRaidRosterInfo(i);
			if(name==UnitName("PLAYER") and isML) then
				Elgoh_LootShow();
			end
		end
	end
end

function Elgoh_Rottgut()
	local kick=0;
	for i = 1, GetNumGuildMembers(), 1 do 
		local _, monthsOffline, daysOffline = GetGuildRosterLastOnline(i);
		local name, rank,_, level,_,_,note, officernote, online = GetGuildRosterInfo(i);
		local notes="";
		if(note~="" and note~=nil) then notes=notes.." - "..note; end
		if(officernote~="" and officernote~=nil) then notes=notes.." - "..officernote; end
		if((online~=1 and (daysOffline>20 and rank=="Alts") and level<40)) then 
			Elgoh_Print("Kicking "..name.." (Inactive "..rank..")"..notes)
			if Remove then GuildUninvite(name); end
			kick=kick+1;
		elseif(online~=1 and (daysOffline>29 or monthsOffline>0) and not string.find(officernote,"NoKick")) then
			Elgoh_Print("Kicking "..name.." (Inactive "..rank..")"..notes)
			if Remove then GuildUninvite(name); end
			kick=kick+1;
		end
	end
	if(kick==0) then Elgoh_Print("No inactive players"); return; end
	if Remove then Remove=false; else Remove=true; Elgoh_Print(kick.." people will be removed"); end
end

function Elgoh_Loaded(self, event, addon)
	if (event == "ADDON_LOADED" and addon:lower()=="elgoh") then		
	
		tinsert(UISpecialFrames,"frmOfficer");
		frmOfficer:SetScript("OnEvent", Elgoh_OnEvent);
		frmOfficer:RegisterEvent("CHAT_MSG_ADDON");
		frmOfficer:RegisterEvent("LOOT_OPENED");
		frmOfficer:SetScript("OnUpdate", Elgoh_OnUpdate);
		frmOfficer:RegisterForDrag("LeftButton");
		
		OElgohVote:RegisterEvent("CHAT_MSG_WHISPER")
		OElgohVote.TimeSinceLastUpdate = 0;
		
		RegisterAddonMessagePrefix("lgoh");
		RegisterAddonMessagePrefix("anoo");
		RegisterAddonMessagePrefix("elgoh");
		RegisterAddonMessagePrefix("EDB1");
		
		Elgoh_OptionsLoaded()
		
		Elgoh_HookTooltips()
		--EDB_Prune(); --Bin out of date entries (Not safe to call on login)
		SendAddonMessage(ElgohDatabaseVersion, "request sync", "GUILD"); --Request a sync to see if there's been any changes
		
		ElgohVers=GetAddOnMetadata("Elgoh", "X-Curse-Packaged-Version")
		if(ElgohVers==nil) then ElgohVers="r1"; end --it's NIL if using the working copy
		ElgohVers = string.sub(ElgohVers, 2); --gets rid of the r
		
		SendAddonMessage("anoo", ElgohVers, "GUILD"); --Addon update check for if they have an older copy
		SendAddonMessage("anoo", "version", "GUILD"); --Addon update check for if YOU have an older copy
		
		Elgoh_Print("Version "..ElgohVers.." has been loaded");
	end
	if(event=="ADDON_LOADED" and addon:lower()=="itemleveldkp") then
		Elgoh_Print("Detected ItemLevelDKP Addon, this will interfere with Elgoh's values");
	end
end

local pruned=0;
frmOfficer.TimeSinceLastUpdate=0;
function Elgoh_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed; 	
	if (self.TimeSinceLastUpdate > 5) then
		if(pruned<6) then 
			pruned=pruned+1;
			if(ElgohDebug==1) then Elgoh_Print(pruned); end
		else
			EDB_Prune()
		end
	if(changethreshhold==1) then
		if(ElgohDebug==1) then Elgoh_Print("Setting threshhold..."); end
		SetLootThreshold(3);
	end
		self.TimeSinceLastUpdate = 0;
	end
end

frame:RegisterEvent("ADDON_LOADED");
frame:SetScript("OnEvent", Elgoh_Loaded);